/*
 * GREAT-ER
 *
 * MC-CHECK.H
 *
 * Monte Carlo - checking whether a shot is OK
 *
 * author =  Geert Boeije
 * state =   9.12.1997
*/

#ifndef MCCHECK_H
#define MCCHECK_H

FloatType BetweenOneZero ( FloatType value_arg );

FloatType OneOrZero ( FloatType value_arg );

FloatType MinusOneToOne ( FloatType value_arg );

FloatType NotNegative ( FloatType value_arg );

FloatType MinusOneOrNotNegative ( FloatType value_arg );

FloatType AboveZero ( FloatType value_arg );

void CheckNonGeoRefShot ( void );

void CheckChemicalShot ( void );

void CheckGeneralShot ( General_ParPtr gen_arg );

void CheckRiverShot ( River_ParPtr river_arg );

void CheckDischargeShot ( FloatPtr shot_arg );

void CheckEmissionShot ( FloatPtr shot_arg );

void CheckWWTPShot ( FloatPtr shot_arg );

void CheckRivClassShot ( FloatPtr shot_arg );

void CheckCSewerQDWFShot ( FloatPtr shot_arg );

#endif
