/*
 * GREAT-ER
 *
 * ERROR.C
 *
 * error messages
 *
 * author =  Geert Boeije
 * state =   12.2.1998
*/

#include <stdio.h>
#include "init.h"
#include "usriface.h"
#include "error.h"

/* Error Messages function */

/*
    parameters are:
      e_arg = error code (see switch below)
      message_arg = pointer to int, char or FloatType message(s) 
                    associated with error message
*/

void GenerateErrorMessage ( int e_arg,
                            void* message_arg )
{
  int* i_msg = (int*)message_arg;
  char* c_msg = (char*)message_arg;
  FloatPtr f_msg = (FloatPtr)message_arg;
  char err_str[100];
  char s[100];

  ErrorFree = 0;
  
  /* in case of a string message, use c_msg
     in case of a FloatType message, use *(f_msg <+ offset>) */

  switch (e_arg)
  {
    /* 100 etc. = files errors */

    case 100: sprintf (err_str, "file \"%s\" could not be opened for output", c_msg);
              break;
    case 101: sprintf (err_str, "file \"%s\" could not be opened for input", c_msg);
              break;
    case 102: sprintf (err_str, "number of segments is not correct");
              break;
    case 103: sprintf (err_str, "data file \"%s\" is not complete", c_msg);
              break;
    case 104: sprintf (err_str, 
              "reading of control parameter file \"%s\" unsuccessful", c_msg);
              break;
    case 105: sprintf (err_str, 
              "data file \"%s\" - incorrect format: lonely '/' encountered", c_msg);
              break;
    case 106: sprintf (err_str, 
              "data file \"%s\" - incorrect format: "
              "non-numerical value outside comment region", c_msg);
              break;
    case 107: sprintf (err_str, "at least one river class must be defined");
              break;
    case 108: sprintf (err_str, "work directory \"%s\" could not be opened", c_msg);
              break;

    /* 500 etc. = seg referencing errors */

    case 501: sprintf (err_str,
              "segment <%f>: "
              "upstream segment <%f> could not be found",
              f_msg[0], f_msg[1]);
              break;

    case 502: sprintf (err_str,
              "segment <%f>: "
              "neighboring segment <%f> could not be found",
              f_msg[0], f_msg[1]);
              break;

    case 503: sprintf (err_str,
              "current segment <%f> discharge data could not be found",
              f_msg[0]);
              break;

    case 504: sprintf (err_str,
              "current segment <%f> market data could not be found",
              f_msg[0]);
              break;

    case 505: sprintf (err_str,
              "first segment <%f> could not be found",
              f_msg[0]);
              break;

    case 506: sprintf (err_str,
              "current segment <%f> river class data "
              "(class <%f>) could not be found",
              f_msg[0], f_msg[1]);
              break;

    case 507: sprintf (err_str,
              "current segment <%f> WWTP data "
              "(class <%f>) could not be found",
              f_msg[0], f_msg[1]);
              break;


    /* 600 etc. = model calculation errors */

    case 601: sprintf (err_str, "division by zero in %s", c_msg);
              break;

    /* 900 etc. = other */

    case 901: sprintf (err_str, "memory allocation unsuccessful");
              break;

    case 903: sprintf (err_str, "river model complexity mode <%d> is invalid "
              "- default mode 1 was selected", i_msg[0]);
              break;

    case 904: sprintf (err_str, "WWTP model complexity mode <%d> is invalid "
              "- default mode 1 was selected", i_msg[0]);
              break;

    case 905: sprintf (err_str, "sewer model complexity mode <%d> is invalid "
              "- default mode 1 was selected", i_msg[0]);
              break;

    case 910: sprintf (err_str, "'impose default complexity mode river' switch <%d> is invalid"
              "- default 0 was selected", i_msg[0]);
              break;

    case 911: sprintf (err_str, "'impose default complexity mode WWTP' switch <%d> is invalid"
              "- default 0 was selected", i_msg[0]);
              break;

    case 912: sprintf (err_str, "'impose default complexity mode sewer' switch <%d> is invalid"
              "- default 0 was selected", i_msg[0]);
              break;

    case 999: sprintf (err_str, "simulation stopped by user (%d percent completed)", i_msg[0]);
              break;

    default:  sprintf (err_str, "undefined");
              break;
  }

  sprintf ( s, "ERROR: %s\n", err_str);

  /* show error message */

  ErrorMessage ( s );
}
