/*
 * GREAT-ER
 *
 * R_MISC.C
 *
 * fate models - calculation of removal rates
 *               in on-site treatment, sewer, groundwater, small surface water
 *
 * author =  Geert Boeije
 * state =   12.02.1998
*/

#include <math.h>
#include "init.h"
#include "model.h"
#include "r_misc.h"


/*
 * ----------------------------------------------------------------------
 * On-site Treatment
 * ----------------------------------------------------------------------
*/


/*
 * on-site removal model
 * ---------------------
*/

FloatType OnSiteRemoval ( FloatPtr  process_x_in_arg,
                          FloatPtr  process_par_arg,
                          FloatPtr  general_par_arg,
                          FloatType leak_arg,
                          int       submodel_arg )
{
  return 0; /* not implemented yet */
}

/*
 * ----------------------------------------------------------------------
 * Sewer
 * ----------------------------------------------------------------------
*/


/*
 * Sewer removal model
 * -------------------
*/

FloatType SewerRemoval ( FloatPtr  process_x_in_arg,
                         FloatPtr  process_par_arg,
                         FloatPtr  general_par_arg,
                         FloatType leak_arg,
                         int       submodel_arg )
{
  int complexity_mode;

  /**************************/
  /* which mode do we use ? */
  /**************************/

  if ( (ComplexityModeSewer != -1) && ImposeComplexityModeSewer )
    complexity_mode = ComplexityModeSewer;
  else
    complexity_mode = 1; /* if nothing is specified, take mode 1 as default */


  switch ( complexity_mode )
  {
    /* mode 1 is conservative transport */  

    case 1:
      return 0;
      break;

    /* currently, only a simple %-removal model is used in mode 2,3*/

    case 2:
    case 3:
      return ChemicalParams->R_sewer;
      break;

    default:
      return 0;
      break;
  }
}


/*
 * ----------------------------------------------------------------------
 * Small Surface Water
 * ----------------------------------------------------------------------
*/

/*
 * surface water removal model
 * ---------------------------
*/

FloatType SmallSurfaceWaterRemoval ( FloatPtr  process_x_in_arg,
                                     FloatPtr  process_par_arg,
                                     FloatPtr  general_par_arg,
                                     FloatType leak_dummy_arg,
                                     int       submodel_dummy_arg ) 
{
  return 0; /* not implemented yet */
}

/*
 * ----------------------------------------------------------------------
 * Groundwater
 * ----------------------------------------------------------------------
*/

/*
 * ground water removal model
 * --------------------------
*/

FloatType GroundWaterRemoval ( FloatPtr  process_x_in_dummy_arg,
                               FloatPtr  process_par_dummy_arg,
                               FloatPtr  general_par_arg,
                               FloatType leak_dummy_arg,
                               int       submodel_dummy_arg ) 
{
  return 0; /* not implemented yet */
}


