/*
 * GREAT-ER
 *
 * USRIFACE.C
 *
 * user interface
 *
 * author =  Geert Boeije
 * state =   28.05.1997
*/

#include <stdio.h>
#include <time.h>
#include "init.h"
#include "usriface.h"
#include "control.h"

#ifdef GUI_MODE
#include <time.h>
#include "extgui.h"
#endif


/* display status */

int DisplayStatus = 0;
int Progress = 0;
int ElapsHours = 0;
int ElapsMinutes = 0;
int ElapsSeconds = 0;
int Hours = 0;
int Minutes = 0;
int Seconds = 0;

/***********************************************************************
 *
 * P L A T F O R M     D E P E N D E N T
 *
 ***********************************************************************
*/


/*
 * ---------------------------------------------------------------------
 * Write to Log device
 * ---------------------------------------------------------------------
*/

void WriteLog ( char* text_arg )
{
  if ( LogToFile )
    if ( LogFile )
      fprintf ( LogFile, text_arg );
}

/*
 * ---------------------------------------------------------------------
 * Write Message in a box - plus wait
 * (only to screen) 
 * ---------------------------------------------------------------------
*/

void WriteMessageInBox ( char *text_arg )
{
  #ifdef GUI_MODE
  if ( ShowMessages )
    OK_Box ( text_arg );
  #else
  if ( ShowMessages )
    printf ( text_arg );
  #endif
}

/*
 * ---------------------------------------------------------------------
 * show error message
 * (both to screen and file)
 * ---------------------------------------------------------------------
*/

void ErrorMessage ( char* text_arg )
{
  #ifdef GUI_MODE
  if ( ShowErrorMessages )
    STOP_Box ( text_arg );
  #else
  if ( ShowErrorMessages )
    printf ( text_arg );
  #endif

  /* write error message to log file */

  if ( LogToFile )
    if ( LogFile )
      fprintf ( LogFile, "\n***\n%s\n***\n", text_arg );

  /* write error message to error log file */

  if ( ErrorFile )
    fprintf ( ErrorFile, text_arg );
}


/*
 * ---------------------------------------------------------------------
 * % finished 
 * ---------------------------------------------------------------------
*/

/* NB: this function causes some meory leaks
   (bug in graphical routines ???)
   but it is only called once per shot */


void PercentDone (int step_arg,
                  long t0_arg,
                  long t1_arg )
{
  int m,s;
  float one_shot;
  long elapsed;
  static int nr_called = 1;

  if ( !Visible )
    return;

  if ( nr_called >= step_arg )
  {
    Progress = (100.0 * Shot) / (float)NrMonteCarloShots;
    elapsed = t1_arg - t0_arg; 

    one_shot = (float)elapsed / (float)Shot;
    s = (NrMonteCarloShots - Shot) * one_shot;
    m = s / 60;
    Seconds = s % 60;
    Hours = m / 60;
    Minutes = m % 60;

    elapsed = t1_arg - StartTime; 

    ElapsSeconds = elapsed % 60;
    elapsed = elapsed - ElapsSeconds;

    ElapsMinutes = elapsed % 3600;
    elapsed = elapsed - ElapsMinutes;
    ElapsMinutes /= 60;

    ElapsHours = elapsed / 3600;

    #ifdef GUI_MODE 
    PaintNow ();
    #else
    printf ("%d %% finished  -  elapsed time = %d:%d:%d  -  estimated time left = %d:%d:%d\r", 
            Progress, ElapsHours, ElapsMinutes, ElapsSeconds, Hours, Minutes, Seconds );
    fflush (stdout);
    #endif

    nr_called = 0;
  }
  else
    ++nr_called;
}

/* NB: next function is never called, it causes memory leaks */

void PercentDone2 ( void )
{
  long elapsed;

  if ( !Visible )
    return;

  elapsed = time(NULL) - StartTime; 

  ElapsSeconds = elapsed % 60;
  elapsed = elapsed - ElapsSeconds;

  ElapsMinutes = elapsed % 3600;
  elapsed = elapsed - ElapsMinutes;
  ElapsMinutes /= 60;

  ElapsHours = elapsed / 3600;

  #ifdef GUI_MODE 
  PaintNow ();
  #endif
}

void ShowExplanation ( void )
{
  #ifdef GUI_MODE 
  ShowExplanationinGUI ();
  #else
  printf ( EXPLANATION );
  #endif
}



